<?php

declare(strict_types=1);

/*
 * Chill is a software for social workers
 *
 * For the full copyright and license information, please view
 * the LICENSE file that was distributed with this source code.
 */

namespace Chill\ActivityBundle\Tests\Export\Aggregator;

use Chill\ActivityBundle\Entity\Activity;
use Chill\ActivityBundle\Export\Aggregator\ActivityReasonAggregator;
use Chill\MainBundle\Test\Export\AbstractAggregatorTest;
use Doctrine\ORM\EntityManagerInterface;
use Prophecy\PhpUnit\ProphecyTrait;

/**
 * @internal
 *
 * @coversNothing
 */
final class ActivityReasonAggregatorTest extends AbstractAggregatorTest
{
    use ProphecyTrait;

    private ActivityReasonAggregator $aggregator;

    protected function setUp(): void
    {
        self::bootKernel();

        $this->aggregator = self::getContainer()->get(ActivityReasonAggregator::class);
        /*
            $request = $this->prophesize()
                ->willExtend(\Symfony\Component\HttpFoundation\Request::class);
            $this->aggregator = self::$container->get(ActivityReasonAggregator::class);

            $request->getLocale()->willReturn('fr');

            self::getContainer()->get('request_stack')
                    ->push($request->reveal());*/
    }

    public function getAggregator()
    {
        return $this->aggregator;
    }

    public static function getFormData(): array
    {
        return [
            ['level' => 'reasons'],
            ['level' => 'categories'],
        ];
    }

    public static function getQueryBuilders(): iterable
    {
        self::bootKernel();
        $em = self::getContainer()->get(EntityManagerInterface::class);

        return [
            $em->createQueryBuilder()
                ->select('count(activity.id)')
                ->from(Activity::class, 'activity')
                ->join('activity.person', 'person'),
            $em->createQueryBuilder()
                ->select('count(activity.id)')
                ->from(Activity::class, 'activity')
                ->join('activity.accompanyingPeriod', 'accompanyingPeriod'),
            $em->createQueryBuilder()
                ->select('count(activity.id)')
                ->from(Activity::class, 'activity')
                ->join('activity.reasons', 'actreasons'),
            $em->createQueryBuilder()
                ->select('count(activity.id)')
                ->from(Activity::class, 'activity')
                ->join('activity.reasons', 'actreasons')
                ->join('actreasons.category', 'actreasoncat'),
        ];
    }
}
